close all;
clear all;

ti = [0:0.05:1, 1.1:0.1:2, 2.2:0.15:3, 3.15:0.2:4, 4.2:0.25:(2*pi)] ;
ti = ti';
ti = ti(2:end);

P = [cos(ti), sin(ti)];
N_P = -P;
P = P/5 + 0.5;
w = ones(numel(ti));
w = w';

S = Poisson2DSolver(P, N_P, w, 4, 4);



figure(1);
hold on;
scatter(P(:,1), P(:,2));
S.T.plot();
S.T.plotV();

[X,Y] = meshgrid(0:0.02:1, 0:0.02:1);
fprintf('Computing the solution on the grid :\n');
Z = (arrayfun(@S.sol, X, Y));
[C,h] = contour(X, Y, Z);
clabel(C,h);
fprintf('\n');
axis([0,1,0,1]);
axis square;
hold off;


figure(2);
hold on;
scatter(P(:,1), P(:,2));
S.T.plot();
contour(X, Y, Z, [0,0], 'LineColor', 'r');
fprintf('\n');
axis([0,1,0,1]);
axis square;
hold off;


figure(3);
hold on;
scatter(P(:,1), P(:,2));
S.T.plot();
S.T.plotV();

[X2,Y2] = meshgrid(0.5:0.01:0.75, 0.5:0.01:0.75);
fprintf('Computing the solution on the grid :\n');
Z2 = (arrayfun(@S.sol, X2, Y2));
contour(X2, Y2, Z2, [0,0], 'LineColor', 'r');
fprintf('\n');
axis([0,1,0,1]);
axis square;
hold off;

figure(4);
hold on;
scatter(P(:,1), P(:,2));
S.T.plot();
%S.T.plotV();
contour(X, Y, Z, [0,0], 'LineColor', 'r', 'Linewidth', 2);
contour(X2, Y2, Z2, [0,0], 'LineColor', 'g', 'Linewidth', 2);
fprintf('\n');
axis([0,1,0,1]);
axis square;
hold off;
